import 'package:zhiying_comm/util/empty_util.dart';
import 'package:zhiying_comm/util/global_config.dart';
import 'package:zhiying_comm/util/log/let_log.dart';
import 'package:zhiying_comm/util/net_util.dart';

class MessageNoticeRepository {
  final int _maxSize = 5;
  int _currentPage = 1;
  bool _hasMoreData = true;
  List<dynamic> _oldData = [];

  /// 下拉刷新
  Future<dynamic> fetchRefreshData() async {
    return fetchInitData();
  }

  /// 上拉更多
  Future<dynamic> fetchLoadData() async {
    if (_hasMoreData) {
      return _baseRequest();
    }
    return null;
  }

  /// 数据初始化
  Future<dynamic> fetchInitData() async {
    _currentPage = 1;
    _hasMoreData = true;
    _oldData.clear();
    return _baseRequest();
  }

  /// 基础请求
  Future<dynamic> _baseRequest() async {
    try {
      var result = await NetUtil.post('', params: {'size': _maxSize.toString()});
      if (NetUtil.isSuccess(result) && !EmptyUtil.isEmpty(result[GlobalConfig.HTTP_RESPONSE_KEY_DATA])) {
        ++_currentPage;
      }
    } catch (e, s) {
      Logger.error(e, s);
    }
    return null;
  }
}
